#include "StdAfx.h"
#include "WASUpdateBuddy.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"


CWASUpdateBuddy::CWASUpdateBuddy(CWASActor *pActor) : 
	CWASCommand(pActor)
{
	m_eError = wasError_Etc;
    m_nNewGrpID = 0;
}


CWASUpdateBuddy::~CWASUpdateBuddy(void)
{
}


void CWASUpdateBuddy::ExecuteAsync()
{
	USES_UTF8_CONVERSION;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/buddy/MoveBuddy.php");


	char szTemp[64];	

	m_httpFacade.session().SetURL(W2U8(strURL.c_str()),	pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));

	sprintf(szTemp, "%d", m_nNewGrpID);
	m_httpFacade.session().AddBodyVariable("newgrpid", szTemp);

	m_httpFacade.session().AddBodyVariable("ostype", W2U8(_T("1")));

	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());

	wstring strBuddyID;
	vector< pair<wstring, int> >::const_iterator itr = m_vecBuddy.begin();
	for(; itr != m_vecBuddy.end(); itr++ )
	{
		if( strBuddyID.empty() != true )
			strBuddyID += _T(",");

		WCHAR buf[256];
		wsprintf(buf, L"%s|%d", itr->first.c_str(), itr->second);
		strBuddyID += buf;
	}
	m_httpFacade.session().AddBodyVariable("buddyids", W2U8(strBuddyID.c_str()));

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	
	m_httpFacade.SendRequest(this);
}



bool CWASUpdateBuddy::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	nfc::IIkXMLAttribute * pAttr;
	nfc::IIkXMLNode * pNode;
    
    pNode = pDom->GetdocumentElement()->selectSingleNode("result");
	if(pNode == NULL)
		return false;
    
	pAttr = pNode->getAttribute("code");
	if( pAttr )
	{
		int nResult = atoi(pAttr->Gettext().c_str());
		if( nResult == 100 )
			m_eError = wasError_None;
		else if( nResult == 205 )
			m_eError = wasError_DuplicateBuddy;
	}

	return true;
}


// override in drived class
void CWASUpdateBuddy::OnWasResponse(trid_t trid,
								  bool bSuccess,
								  int /*nWinINetErrorCode*/, 
								  int /*nHttpResponseCode*/, 
                                  LPCSTR /*szWasResCodeInHeader*/, 
                                  LPCSTR szWasResCodeInXml,
                                  nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

//	GT_BUDDY_UPDATABLE_DATA sData;
//	m_sBuddyInfo.Convert(sData);

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseUpdateBuddy(m_pActor, GetID(), m_eError, m_vecBuddy, m_nNewGrpID) == false)
			break;
	}

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASUpdateBuddy::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

//	GT_BUDDY_UPDATABLE_DATA sData;
//	m_sBuddyInfo.Convert(sData);

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseUpdateBuddy(m_pActor, GetID(), m_eError, m_vecBuddy, m_nNewGrpID) == false)
			break;
	}

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
